﻿ej.parseJSON = function (jsonText) {
    var type = typeof jsonText;
    if (type === "string") {
        jsonText = JSON.parse(jsonText, p.jsonReviver);
    } else if (jsonText instanceof Array) {
        iterateAndReviveArray(jsonText);
    } else if (type === "object")
        iterateAndReviveJson(jsonText);
    return jsonText;
}
    function iterateAndReviveArray(array) {
        for (var i = 0; i < array.length; i++) {
            if (typeof array[i] === "object")
                iterateAndReviveJson(array[i]);
            else if (typeof array[i] === "string" && !/^[\s]*\[|^[\s]*\{|\"/g.test(array[i]))
                array[i] = jsonReviver("", array[i]);
            else
                array[i] = ej.parseJSON(array[i]);
        }
    }
    function iterateAndReviveJson(json) {
        var value;

        for (var prop in json) {
            if (prop.startsWith("__"))
                continue;

            value = json[prop];
            if (typeof value === "object") {
                if (value instanceof Array)
                    iterateAndReviveArray(value);
                else
                    iterateAndReviveJson(value);
            } else
                json[prop] = jsonReviver(prop, value);
        }
    }
    function jsonReviver(field, value) {
        var s = value;
        if (typeof value === "string") {
            var ms = /^\/Date\(([+-]?[0-9]+)([+-][0-9]{4})?\)\/$/.exec(value);
            if (ms)
                return new Date(parseInt(ms[1]));
            else if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*)?)([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(value)) {
                value = new Date(value);
                value = new Date(value.getTime() + (value.getTimezoneOffset() * 60000));
                if (isNaN(value)) {
                    var a = s.split(/[^0-9]/);
                    value = new Date(a[0], a[1] - 1, a[2], a[3], a[4], a[5]);
                }
            }
        }

        return value;
    }
